#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	static bool getModuleProperties (SEModuleProperties* properties); 
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void SE_CALLING_CONVENTION sub_process_static(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	virtual void open();
	void FillTable(int seedvalue);

private:
	float *input1_buffer; 
	float *input2_buffer;
	short mode, start, end;
	float *output1_buffer;
	float *output2_buffer;
	float clock, prev_clock, reset, prev_reset;
	int num_pulses, first_count, second_count, direction, seed, old_seed;
	int static_count;
	float* random_table;
	float randnum;
};
#endif
