#pragma once
#include "segui_base.h"

class GuiModule :
	public SEGUI_base

{
public:
	GuiModule(seGuiCallback seaudioMaster, void *p_resvd1);
	~GuiModule(void);
	void Initialise(bool loaded_from_file);
	virtual void paint(HDC hDC, SEWndInfo *wi);
	virtual void OnLButtonDown( SEWndInfo *wi, UINT nFlags, sepoint point );
	virtual void OnLButtonUp( SEWndInfo *wi, UINT nFlags, sepoint point );
	virtual void OnMouseMove( SEWndInfo *wi, UINT nFlags, sepoint point );
	virtual void OnGuiPinValueChange(SeGuiPin *p_pin);
	void UpdatePositions( float *pos_array, const SeSdkString &p_values );
//	virtual void OnModuleMsg(int p_user_msg_id,int p_length, void *p_data);
private:

	static float StringToFloat(const SeSdkString &p_string);
	SeSdkString DefaultValue();
	SeSdkString GetValueS();
	void SetValueS(SeSdkString p_string);
	void OnValueChanged();
//	void SendStringToAudio( int p_length, void *p_data );

	int svalue, draw_p, which_drag;
	int InvalidateControl(void);
	float* pos_array;
	bool m_inhibit_update;
//	int index_from_module;
};
